use crate::util::IntoTableRow;
use jm_client_core::api::{Category, Meme, User};
use term_table::{row::Row, table_cell::TableCell};

impl IntoTableRow for Category {
    fn into_table_row(&self) -> Row<'_> {
        Row::new(vec![TableCell::new(&self.id), TableCell::new(&self.name)])
    }
}

impl IntoTableRow for Meme {
    fn into_table_row(&self) -> Row<'_> {
        Row::new(vec![
            TableCell::new(&self.link),
            TableCell::new(&self.category),
            TableCell::new(&self.user),
        ])
    }
}

impl IntoTableRow for User {
    fn into_table_row(&self) -> Row<'_> {
        Row::new(vec![
            TableCell::new(&self.name),
            TableCell::new(&self.get_id().map(String::as_ref).unwrap_or("[No ID]")),
            TableCell::new(&self.dayuploads),
        ])
    }
}
